﻿using System;
using RomeScriptInterfaces;
using Scripts;

namespace Scripts
{
    [Serializable]
    public class RoTMLEasy : ScriptServer.IScript
    {
  
        private TMilitaryAI mMilitaryAI = null;
        private InvasionSetup[] mInvasions;
       
        private enum EventList : uint
        {    
            kScriptStart,
            kLoadState,
            kScriptDone,          // We'll check for this at the end to set ScriptDone to true


        }
        // for our messaging
        private String msgTitle;
        private String msgText; 
        private String msgWarn;
        private String msgSound;

        private EventList scriptState = EventList.kScriptStart;
        private EventList loadState = EventList.kScriptStart;

     
        // Equite Building ID's
        //government
        private Int32 mIDTaxOffice = IDMaker.FromString("C4b Office Tax Collector");
        //health
        private Int32 mIDBarber = IDMaker.FromString("C4b service Barber shop");
        private Int32 mIDBathhouse = IDMaker.FromString("C4b service Bathhouse");
        private Int32 mIDClinic = IDMaker.FromString("C4b service Clinic");
        private Int32 mIDHospital = IDMaker.FromString("C4b service Hospital");
        //religion
        private Int32 mIDJupiterShrine = IDMaker.FromString("C4b Service Shrine Jupiter");
        private Int32 mIDJupiterTemple = IDMaker.FromString("C4b Service Temple Jupiter");
        private Int32 mIDMarsShrine = IDMaker.FromString("C4b Service Shrine Mars");
        private Int32 mIDMarsTemple = IDMaker.FromString("C4b Service Temple Mars");
        private Int32 mIDMercuryShrine = IDMaker.FromString("C4b Service Shrine Mercury");
        private Int32 mIDMercuryTemple = IDMaker.FromString("C4b Service Temple Mercury");
        private Int32 mIDBacchusShrine = IDMaker.FromString("C4b Service Shrine Bacchus");
        private Int32 mIDBacchusTemple = IDMaker.FromString("C4b Service Temple Bacchus");
        private Int32 mIDCeresShrine = IDMaker.FromString("C4b Service Shrine Ceres");
        private Int32 mIDCeresTemple = IDMaker.FromString("C4b Service Temple Ceres");
        //education
        private Int32 mIDSchool = IDMaker.FromString("C4b Service School");
        private Int32 mIDLibrary = IDMaker.FromString("C4b Service Library");
        //entertainment
        private Int32 mIDOdeum = IDMaker.FromString("C4b Service Odeum");
        private Int32 mIDTheater = IDMaker.FromString("C4b Service Theater");
        private Int32 mIDArena = IDMaker.FromString("C4b Service Arena");
        private Int32 mIDActor = IDMaker.FromString("C4b Training Actor");
        private Int32 mIDGladiator = IDMaker.FromString("C4b Training Gladiator");
        //water 
        private Int32 mIDFountain = IDMaker.FromString("C4b Infra Fountain");
        private Int32 mIDReservoir = IDMaker.FromString("C4b Service Reservoir");
        private Int32 mIDPumphouse = IDMaker.FromString("C4b Infra Pumphouse");
        //military
        private Int32 mIDDrillYard = IDMaker.FromString("C4b Mil Drill Yard");
        //Other Building ID's
        //Markets
        private Int32 mIDFoodMarket = IDMaker.FromString("C4b Market Food");
        private Int32 mIDBasicMarket = IDMaker.FromString("C4b market Common");
        private Int32 mIDLuxuryMarket = IDMaker.FromString("C4b Market Luxury");
        private Int32 mIDExoticMarket = IDMaker.FromString("C4b Market Exotic");
        private Int32 mIDTradeDepot = IDMaker.FromString("C4b Depot");
        //Raw Materials
        private Int32 mIDIronCamp = IDMaker.FromString("C4b harvester Iron miner’s house");
        private Int32 mIDClayCamp = IDMaker.FromString("C4b harvester Clay collector's house");
        private Int32 mIDMarbleCamp = IDMaker.FromString("C4b harvester Marble collector's camp");
        //Decoration
        private Int32 mIDStatue6 = IDMaker.FromString("C4 Deco Statue 6");
        private Int32 mIDGarden = IDMaker.FromString("C4 Deco Garden");

        //Build Buttons
        private Int32 mUIIDMarble = -896256229;
        private Int32 mUIIDClay = 1389655975;
        private Int32 mUIIDIron = 1389655977;
        private Int32 mUIIDHospital = -1282219393;
        private Int32 mUIIDLibrary = -1298997110;

        private Int32 mUIIDSalary = 989726645;
        private Int32 mUIIDGift = 989726641;





        //switches for events
       
        private bool bInit = false;
        private bool b1000DebtMessage = false;        
        private bool bSaveMessage = false;
        private bool bMissionary3 = false;
        private bool bMissionary5 = false;
        private bool bMissionary8 = false;
        private bool bMissionary9 = false; 
        private bool bMissionary10 = false;
        private bool bNative1 = false;
        private bool bNative2 = false;
        private bool bNative3 = false;
        private bool bNative4 = false;
        private bool bNative5 = false;
        private bool bNative6 = false;
        private bool bNative7 = false;
        private bool bNative8 = false;
        private bool bNative9 = false;
        private bool bNative10 = false;
        private bool bNative11 = false;
        private bool bTrade0 = false;
        private bool bTrade3 = false;
        private bool bTrade4 = false;
        private bool bTrade5 = false;
        private bool bTrade6 = false;
        private bool bTrade7 = false;
        private bool bTrade8 = false;
        private bool bInitialWagesSet = false;
        private bool bSpirit = false;
        private bool bSeaTrade = false;
        private bool bNeptuneRise = false;
        private bool bNeptuneFall = false;
        private bool bTrade2 = false;
        private bool bBlessing = false;
        private bool bCurse = false;
        private bool bTrade6a = false;
        private bool bTrade7a = false;
        private bool bTrade8a = false;
        private bool bTradeBoost2 = false;
        private bool bTradeBoost6 = false;
        private bool bTradeBoost7 = false;
        private bool bTradeBoost8 = false;
        private bool bExtraMarket = false;
        private bool b2ndMarketMessage = false;
        private bool bNativeTipShown = false;
        private bool bNeptuneTipShown = false;












        //variables

        private uint iSave = 1;
        private uint iNative = 1;
        private uint iInvasions = 1;
        private uint tInvasions = 420;
        private uint iBlessing = 1;
        private uint tBlessing = 481;
        private uint tNative = 40;
        private uint tSave = 5;
        private uint nTime = 0;
        private uint numMarbleCamp = 0;
        private uint numClayCamp = 0;
        private uint numIronCamp = 0;
        private uint tCollapse = 20;
        private uint tWageCheck = 970;
        private uint tNextAnkCheck = 80;

        private uint numFoodMarket = 0;
        private uint numBasicMarket = 0;
        private uint numLuxuryMarket = 0;
        private uint numJupiterTemple = 0;
        private uint numCeresTemple = 0;
        private uint numMarsTemple = 0;
        private uint numMercuryTemple = 0;
        private uint numBacchusTemple = 0;
        private uint numNeptuneTemple = 0;
        private uint numNeptuneTempleOld = 0;
        private uint numSchool = 0;
        private uint numClinic = 0;
        private uint numBathhouse = 0;
        private uint numBarber = 0;
        private uint numLibrary = 0;
        private uint numHospital = 0;
        private uint numReservoir = 0;
        private uint numPumphouse = 0;
        private uint numFountain = 0;
        private uint numTaxOffice = 0;
        private uint numOdeum = 0;
        private uint numTheater = 0;
        private uint numArena = 0;
        private uint numActor = 0;
        private uint numGladiator = 0;
        private uint numDrillYard = 0;
        private uint numJupiterTempleOld = 0;
        private uint numCeresTempleOld = 0;
        private uint numMarsTempleOld = 0;
        private uint numMercuryTempleOld = 0;
        private uint numBacchusTempleOld = 0;
        private uint numSchoolOld = 0;
        private uint numClinicOld = 0;
        private uint numBathhouseOld = 0;
        private uint numBarberOld = 0;
        private uint numLibraryOld = 0;
        private uint numHospitalOld = 0;
        private uint numReservoirOld = 0;
        private uint numPumphouseOld = 0;
        private uint numFountainOld = 0;
        private uint numTaxOfficeOld = 0;
        private uint numOdeumOld = 0;
        private uint numTheaterOld = 0;
        private uint numArenaOld = 0;
        private uint numActorOld = 0;
        private uint numGladiatorOld = 0;
        private uint numDrillYardOld = 0;
        private uint numTotalEquiteAssessment = 0;
        private uint numOldEquiteAssessment = 10;
        private uint numAdjEquiteAssessment = 10;
        private int numPlebWages = 0;
        private int numEquiteWages = 0;
        private int nNeptuneSwitch = 0;
        private uint tNextNeptuneCheck= 16;
        private int nNeptuneTarget = 50;
        private int numMaxTemple= 0;
        private int nPopulation = 0;
        private int nNeptune = 50;
        private uint numGarden = 0;
        private uint numGardenOld = 0;
        private int nAnkAdd = 0;
        private int nNeptuneAnk = 0;
        private int nTreasury = 0;
        private uint nFavor = 40;
        private uint tBoostTrade = 0;


// The following declarations are necessary as this scenario uses custom standard wage changes
        private StandardWageManager mWageManagerPlebe = null;
        private StandardWageManager mWageManagerEques = null;
        
          
        
        // local instance of the Toolset (support functions from Tools.cs)
        // We have to run its Init() for it to work!
        private Toolset Tools;
        //
               // This is the main script loop


        public void Run(object gameInterface)
        {
            IGameQueryInterface gameQueryInterface = (IGameQueryInterface)gameInterface;
            switch (gameQueryInterface.RunReason)
            {
                case RunReason.kTick:
                    OnTick(gameQueryInterface);
                    break;

                case RunReason.kOnBeginScenario:
                    OnBeginScenario(gameQueryInterface);
                    break;

                case RunReason.kOnInvasionArrival:
                    OnInvasionArrival(gameQueryInterface);
                    break;

                case RunReason.kOnCohortTargetDestroyed:
                    OnCohortTargetDestroyed(gameQueryInterface);
                    break;

                case RunReason.kOnLoadScenario:
                    OnScenarioLoad(gameQueryInterface);
                    break;
            }
        }

        void OnTick(IGameQueryInterface game)
        { 
            nTime = game.GameTime / 1000;

            if (bInit)
            {
                bInit = false;
                ResetBaseUI(game);
                game.ScriptDone = false;
            }
               
                GetMissionaries(game);
                DetermineTradeRoute(game);
                CheckTreasury(game);
                CheckFavor(game);
                TriggerNeptuneMessage(game);
                ShowTips(game);

                if (nTime <= 10)  SetInitialWages(game);
                if (tCollapse <= nTime) AngryNatives(game);              
                if (tWageCheck <= nTime) GetWages(game);
                if (tNative <= nTime) NativeTrade(game);
                if (tSave <= nTime) CheckForSave(game);
                if (tInvasions <= nTime) InvasionSequence(game);
                if (tNextNeptuneCheck <= nTime) CheckNeptune(game);
                if (tBlessing <= nTime) NeptuneBlessings(game);
                if (tNextAnkCheck <= nTime) NeptuneCurses(game);
                if (tBoostTrade <= nTime) BoostTrade(game);
                
                
        }


        void ShowTips(IGameQueryInterface game)
        {
            if ((!bNativeTipShown) && (iNative <= 9) && (nTime >= 1200))
            {
                msgTitle = "NativeTip_Title";
                msgText = "NativeTip_Message";
                msgSound = "message1.mp3";
                game.SendGameMessage((uint)MessageCategory.kLocalEventMessage,
                            (uint)MessageDisplay.kMessageDisplayTutorial, ref msgTitle, ref msgText, ref msgSound);
                bNativeTipShown = true;
            }
            if ((!bNeptuneTipShown) && (nTime >= 280))
            {
                msgTitle = "NeptuneTip_Title";
                msgText = "NeptuneTip_Message";
                msgSound = "message1.mp3";
                game.SendGameMessage((uint)MessageCategory.kLocalEventMessage,
                            (uint)MessageDisplay.kMessageDisplayTutorial, ref msgTitle, ref msgText, ref msgSound);
                bNeptuneTipShown = true;
            }


        }
        void BoostTrade(IGameQueryInterface game)
        {
            {
                if (bTradeBoost2) game.OpenTradeRoute(2);
                if (bTradeBoost6) game.OpenTradeRoute(6);
                if (bTradeBoost7) game.OpenTradeRoute(7);
                if (bTradeBoost8) game.OpenTradeRoute(8);
            }
            tBoostTrade = nTime + 45;
        }
        void CheckFavor(IGameQueryInterface game)
        {
            game.GetFavorRating(out nFavor);
            if (nFavor == 0)
            {
                game.ScriptDone = true;
                game.OpenTradeRoute(0);
            }
        }
        void SetInitialWages(IGameQueryInterface game)
        {
            if (!bInitialWagesSet)
            {
                numPlebWages = 6;
                numEquiteWages = 12;
                game.SetRomeStandardRate(true, numPlebWages);
                game.SetRomeStandardRate(false, numEquiteWages);
                bInitialWagesSet = true;
            }
        }

        void CheckNeptune(IGameQueryInterface game)
        {
            
            game.GetActiveBuildings(mIDStatue6, out numNeptuneTemple);
            game.GetPopulation(out nPopulation);




            if ((nPopulation <= 200) && (numNeptuneTemple == 0)) nNeptuneSwitch = 0;
            else if ((nPopulation <= 500) && (numNeptuneTemple == 0)) nNeptuneSwitch = 1;
            else if (numNeptuneTemple == 0) nNeptuneSwitch = 2;
            else if (numNeptuneTemple == 1) nNeptuneSwitch = 3;
            else if (numNeptuneTemple >= 2) nNeptuneSwitch = 4;
            
            switch (nNeptuneSwitch)
            {
                case 0:
                    nNeptuneTarget = 50;
                    break;
                
                case 1:
                    nNeptuneTarget = 35;
                   break;

               case 2:
                   nNeptuneTarget = 0;
                   break;


              case 3:
                   
                  if ((nPopulation / numNeptuneTemple) <= 1700) nNeptuneTarget = 80;
                  else if (((nPopulation) / (numNeptuneTemple) >= 1701) &&  ((nPopulation) / (numNeptuneTemple) <= 1800)) nNeptuneTarget = 70;
                  else if (((nPopulation) / (numNeptuneTemple) >= 1801) &&  ((nPopulation) / (numNeptuneTemple) <= 1900)) nNeptuneTarget = 60;
                  else if (((nPopulation) / (numNeptuneTemple) >= 1901) &&  ((nPopulation) / (numNeptuneTemple) <= 2000)) nNeptuneTarget = 50;
                  else if (((nPopulation) / (numNeptuneTemple) >= 2001) &&  ((nPopulation) / (numNeptuneTemple) <= 2200)) nNeptuneTarget = 40;
                  else if (((nPopulation) / (numNeptuneTemple) >= 2201) &&  ((nPopulation) / (numNeptuneTemple) <= 2500)) nNeptuneTarget = 30;
                  else if (((nPopulation) / (numNeptuneTemple) >= 2501) &&  ((nPopulation) / (numNeptuneTemple) <= 3000)) nNeptuneTarget = 20;
                  else if (((nPopulation) / (numNeptuneTemple) >= 3001) &&  ((nPopulation) / (numNeptuneTemple) <= 4000)) nNeptuneTarget = 10;
                  else if ((nPopulation) / (numNeptuneTemple) >= 4000) nNeptuneTarget = 0;
                  break;

              case 4:
                  if ((nPopulation / numNeptuneTemple) <= 1500) nNeptuneTarget = 100;
                  else if (((nPopulation) / (numNeptuneTemple) >= 1501) && ((nPopulation) / (numNeptuneTemple) <= 1600)) nNeptuneTarget = 95;
                  else if (((nPopulation) / (numNeptuneTemple) >= 1601) && ((nPopulation) / (numNeptuneTemple) <= 1700)) nNeptuneTarget = 90;
                  else if (((nPopulation) / (numNeptuneTemple) >= 1701) && ((nPopulation) / (numNeptuneTemple) <= 1800)) nNeptuneTarget = 80;
                  else if (((nPopulation) / (numNeptuneTemple) >= 1801) && ((nPopulation) / (numNeptuneTemple) >= 1900)) nNeptuneTarget = 70;
                  else if (((nPopulation) / (numNeptuneTemple) >= 1901) && ((nPopulation) / (numNeptuneTemple) <= 2000)) nNeptuneTarget = 60;
                  else if (((nPopulation) / (numNeptuneTemple) >= 2001) && ((nPopulation) / (numNeptuneTemple) <= 2200)) nNeptuneTarget = 50;
                  else if (((nPopulation) / (numNeptuneTemple) >= 2201) && ((nPopulation) / (numNeptuneTemple) <= 2500)) nNeptuneTarget = 40;
                  else if (((nPopulation) / (numNeptuneTemple) >= 2501) && ((nPopulation) / (numNeptuneTemple) <= 3000)) nNeptuneTarget = 30;
                  else if (((nPopulation) / (numNeptuneTemple) >= 3001) && ((nPopulation) / (numNeptuneTemple) <= 4000)) nNeptuneTarget = 20;
                  else if ((nPopulation) / (numNeptuneTemple) >= 4000) nNeptuneTarget = 10;
                        break;
            }
          
            
           if (nPopulation <= 200) nNeptune = 50;
               
           else
            {
                if ((nNeptuneTarget) > (nNeptune))
                {
                    bNeptuneRise = true;
                    bNeptuneFall = false;
                }
                if ((nNeptuneTarget) < (nNeptune))
                {
                    bNeptuneRise = false;
                    bNeptuneFall = true;
                }
                if ((nNeptuneTarget) == (nNeptune))
                {
                    bNeptuneRise = false;
                    bNeptuneFall = false;
                }
                {
                    if (bNeptuneRise) nNeptune+=3;
                    if (bNeptuneFall) nNeptune-=3;
                }
                
            }
            if (nNeptune <= 44)
                bBlessing = false;
            
            tNextNeptuneCheck = nTime + 16;
            

            }
        void TriggerNeptuneMessage(IGameQueryInterface game)
        {
            game.GetActiveBuildings(mIDGarden, out numGarden);
            if (numGarden > numGardenOld)
            {
                DisplayNeptuneMood(game);
                numGardenOld = numGarden;
            }
            else numGardenOld = numGarden;

        }

                    void DisplayNeptuneMood(IGameQueryInterface game)
                    {
                        if (nNeptune >= 98)
                        {
                            DisplayWarning(game, "NeptuneExalted");
                        }
                        else if ((nNeptune >= 89) && (nNeptune <= 97))
                        {
                            DisplayWarning(game, "NeptuneDelighted");
                        }
                        else if ((nNeptune >= 78) && (nNeptune <= 88))
                        {
                            DisplayWarning(game, "NeptuneCharmed");
                        }
                        else if ((nNeptune >= 67) && (nNeptune <= 77))
                        {
                            DisplayWarning(game, "NeptuneHappy");
                        }
                        else if ((nNeptune >= 56) && (nNeptune <= 66))
                        {
                            DisplayWarning(game, "NeptunePleased");
                        }
                        else if ((nNeptune >= 45) && (nNeptune <= 55))
                        {
                            DisplayWarning(game, "NeptuneIndifferent");
                        }
                        else if ((nNeptune >= 34) && (nNeptune <= 44))
                        {
                            DisplayWarning(game, "NeptuneDispleased");
                        }
                        else if ((nNeptune >= 23) && (nNeptune <= 33))
                        {
                            DisplayWarning(game, "NeptuneIrritated");
                        }
                        else if ((nNeptune >= 12) && (nNeptune <= 22))
                        {
                            DisplayWarning(game, "NeptuneAngry");
                        }
                        else if ((nNeptune >= 3) && (nNeptune <= 11))
                        {
                            DisplayWarning(game, "NeptuneVeryAngry");
                        }
                        else if (nNeptune <= 2)
                        {
                            DisplayWarning(game, "NeptuneWrathful");
                        }
                    if (nNeptuneAnk >= 90)
                        {
                            DisplayWarning(game, "Neptune5Anks");
                        }
                    else if (nNeptuneAnk >= 70)
                        {
                            DisplayWarning(game, "Neptune4Anks");
                        }
                    else if (nNeptuneAnk >= 48)
                        {
                            DisplayWarning(game, "Neptune3Anks");
                        }
                    else if (nNeptuneAnk >= 25)
                        {
                            DisplayWarning(game, "Neptune2Anks");
                        }
                    else if (nNeptuneAnk >= 2)
                        {
                            DisplayWarning(game, "Neptune1Ank");
                        }
                        else DisplayWarning(game, "Neptune0Anks");

  
                }

        void NeptuneCurses(IGameQueryInterface game)
        {
            game.GetCityFunds(out nTreasury);
            Random nRand = new Random((int)nTreasury);
            int iPoint = (int)nRand.Next(1, 400);
            

            {
                if (nNeptune >= 50)
                {
                    nNeptuneAnk = 0;
                    nAnkAdd = 0;
                }
                else if (nNeptune >= 45) nAnkAdd = 1;
                else if (nNeptune >= 34) nAnkAdd = 2;
                else if (nNeptune >= 25) nAnkAdd = 4;
                else if (nNeptune >= 15) nAnkAdd = 8;
                else if (nNeptune >= 8) nAnkAdd = 13;
                else nAnkAdd = 18;
            }
            {
                nNeptuneAnk += nAnkAdd;
           }
            if (nNeptuneAnk > 100) nNeptuneAnk = 100;

            if (nNeptuneAnk > 80) bCurse = true;

            if ((nNeptuneAnk > iPoint) && bCurse)
            {
                Int32 mQuake = IDMaker.FromString("Long Earthquake");
                game.TriggerDisasterEffect(mQuake);
                DisplayMessage(game, "NeptuneMajorCurse");
                game.TriggerStructureDamage(mIDJupiterTemple, 1, 100);
                game.TriggerStructureDamage(mIDCeresTemple, 1, 100);
                game.TriggerStructureDamage(mIDMarsTemple, 1, 100);
                game.TriggerStructureDamage(mIDBacchusTemple, 1, 100);
                game.TriggerStructureDamage(mIDMercuryTemple, 1, 100);
                nNeptune += 20;
                nNeptuneAnk = 0;
                bCurse = false;
                tNextAnkCheck = nTime + 160;
                 
            }

            if ((nNeptuneAnk > iPoint) && !bCurse)
            {
                Int32 mQuake = IDMaker.FromString("Short Earthquake");
                game.TriggerDisasterEffect(mQuake);
                DisplayMessage(game, "NeptuneCurse");
                nNeptune += 20;
                nNeptuneAnk = 0;
                bCurse = false;
                tNextAnkCheck = nTime + 160;
            }
            if (nNeptuneAnk <= iPoint) tNextAnkCheck = nTime + 80;
        }
 
        
        
        void NeptuneBlessings (IGameQueryInterface game)
        {
            game.GetIsTradeRouteOpen(6, out bTrade6a);
            game.GetIsTradeRouteOpen(7, out bTrade7a);
            game.GetIsTradeRouteOpen(8, out bTrade8a);
            switch (iBlessing)
            {
                case 1:
                    if ((nNeptune >= 98) && (!bBlessing))
                    {
                        DisplayMessage(game, "NeptuneBlessing");
                        if (bTrade2) bTradeBoost2 = true;
                        if (bTrade6a) bTradeBoost6 = true;
                        if (bTrade7a) bTradeBoost7 = true;
                        if (bTrade8a) bTradeBoost8 = true;
                        tBlessing = 801;
                        iBlessing ++;
                        bBlessing = true;
                    }
                    else
                    {
                        tBlessing = 801;
                        iBlessing = 3;
                    }
                    break;

                case 2:
                    if ((nNeptune >= 98) && (!bBlessing))
                    {
                        DisplayMessage(game, "NeptuneBlessing");
                        if (bTrade2) bTradeBoost2 = true;
                        if (bTrade6a) bTradeBoost6 = true;
                        if (bTrade7a) bTradeBoost7 = true;
                        if (bTrade8a) bTradeBoost8 = true;
                        tBlessing = 955;
                        iBlessing++;
                        bBlessing = true;
                    }
                    else
                    {
                        tBlessing = 955;
                        iBlessing++;
                    }
                    break;

                    case 3:
                    {
                        bTradeBoost2 = false;
                        bTradeBoost6 = false;
                        bTradeBoost7 = false;
                        bTradeBoost8 = false;
                        tBlessing = 1361;
                        iBlessing++;
                        break;
                    }

                case 4:
                    if ((nNeptune >= 98) && (!bBlessing))
                    {
                        DisplayMessage(game, "NeptuneBlessing");
                        if (bTrade2) bTradeBoost2 = true;
                        if (bTrade6a) bTradeBoost6 = true;
                        if (bTrade7a) bTradeBoost7 = true;
                        if (bTrade8a) bTradeBoost8 = true;
                        tBlessing = 1915;
                        iBlessing++;
                        bBlessing = true;
                    }
                    else
                    {
                        tBlessing = 1915;
                        iBlessing++;
                    }
                    break;

                case 5:
                    {
                        bTradeBoost2 = false;
                        bTradeBoost6 = false;
                        bTradeBoost7 = false;
                        bTradeBoost8 = false;
                        tBlessing = 2481;
                        iBlessing++;
                        break;
                    }
                case 6:

                    if ((nNeptune >= 98) && (!bBlessing))
                    {
                        DisplayMessage(game, "NeptuneBlessing");
                        if (bTrade2) bTradeBoost2 = true;
                        if (bTrade6a) bTradeBoost6 = true;
                        if (bTrade7a) bTradeBoost7 = true;
                        if (bTrade8a) bTradeBoost8 = true;
                        tBlessing = 2875;
                        iBlessing++;
                        bBlessing = true;
                    }
                    else
                    {
                        tBlessing = 2875;
                        iBlessing++;
                    }
                    break;

                case 7:
                    {
                        bTradeBoost2 = false;
                        bTradeBoost6 = false;
                        bTradeBoost7 = false;
                        bTradeBoost8 = false;
                        tBlessing = 4101;
                        iBlessing++;
                        break;
                    }
                case 8:
                    if ((nNeptune >= 98) && (!bBlessing))
                    {
                        DisplayMessage(game, "NeptuneBlessing");
                        if (bTrade2) bTradeBoost2 = true;
                        if (bTrade6a) bTradeBoost6 = true;
                        if (bTrade7a) bTradeBoost7 = true;
                        if (bTrade8a) bTradeBoost8 = true;
                        tBlessing = 4795;
                        iBlessing++;
                        bBlessing = true;
                    }
                    else
                    {
                        tBlessing = 4795;
                        iBlessing++;
                    }
                    break;

                case 9:
                    {
                        bTradeBoost2 = false;
                        bTradeBoost6 = false;
                        bTradeBoost7 = false;
                        bTradeBoost8 = false;
                        tBlessing = 4801;
                        iBlessing++;
                        break;
                    }
                case 10:
                    if ((nNeptune >= 98) && (!bBlessing))
                    {
                        DisplayMessage(game, "NeptuneBlessing");
                        if (bTrade2) bTradeBoost2 = true;
                        if (bTrade6a) bTradeBoost6 = true;
                        if (bTrade7a) bTradeBoost7 = true;
                        if (bTrade8a) bTradeBoost8 = true;
                        tBlessing = 5675;
                        iBlessing++;
                        bBlessing = true;
                    }
                    else
                    {
                        tBlessing = 5675;
                        iBlessing++;
                    }
                    break;

                case 11:
                    {
                        bTradeBoost2 = false;
                        bTradeBoost6 = false;
                        bTradeBoost7 = false;
                        bTradeBoost8 = false;
                        tBlessing = 7601;
                        iBlessing++;
                        break;
                    }

                case 12:
                    if ((nNeptune >= 98) && (!bBlessing))
                    {
                        DisplayMessage(game, "NeptuneBlessing");
                        if (bTrade2) bTradeBoost2 = true;
                        if (bTrade6a) bTradeBoost6 = true;
                        if (bTrade7a) bTradeBoost7 = true;
                        if (bTrade8a) bTradeBoost8 = true;
                        tBlessing = 7675;
                        iBlessing++;
                        bBlessing = true;
                    }
                    else
                    {
                        tBlessing = 7675;
                        iBlessing++;
                    }
                    break;

                case 13:
                    {
                        bTradeBoost2 = false;
                        bTradeBoost6 = false;
                        bTradeBoost7 = false;
                        bTradeBoost8 = false;
                        tBlessing = 9121;
                        iBlessing++;
                        break;
                    }
                case 14:
                    if ((nNeptune >= 98) && (!bBlessing))
                    {
                        DisplayMessage(game, "NeptuneBlessing");
                        if (bTrade2) bTradeBoost2 = true;
                        if (bTrade6a) bTradeBoost6 = true;
                        if (bTrade7a) bTradeBoost7 = true;
                        if (bTrade8a) bTradeBoost8 = true;
                        tBlessing = 9595;
                        iBlessing++;
                        bBlessing = true;
                    }
                    else
                    {
                        tBlessing = 9595;
                        iBlessing++;
                    }
                    break;

                case 15:
                    break;


            }
        }

        void CheckTreasury(IGameQueryInterface game)
        {
            int numTreasury = 0;

            game.GetCityFunds(out numTreasury);
            {
                if ((!b1000DebtMessage) && (numTreasury <= -1000))
                {
                    //Send Warning Message if debt exceeds 1000
                    msgTitle = "EVENT_Debt1000_Title";
                    msgText = "EVENT_Debt1000_Message";
                    msgSound = "message1.mp3";
                    game.SendGameMessage(
                        (uint)MessageCategory.kLocalEventMessage,
                         (uint)MessageDisplay.kMessageDisplaySignificant,
                        ref msgTitle, ref msgText, ref msgSound);
                    b1000DebtMessage = true;
                }
              
            }
            // open defeat trade route
            if (numTreasury <= -2001)
            {
                game.OpenTradeRoute(0);
            }
            if (numTreasury >= 20000) bExtraMarket = true;

            if ((bExtraMarket) && (!b2ndMarketMessage))
            {
                DisplayMessage(game, "2ndMarket");
                b2ndMarketMessage = true;
            }
        }
        void ResetBaseUI(IGameQueryInterface game)
        {
            game.LockUIControl(mUIIDSalary, Toolset.AdvisorsFormID);
            game.LockUIControl(mUIIDGift, Toolset.AdvisorsFormID);


                if (iNative <=3)
                {
                    game.LockUIControl(mUIIDMarble, Toolset.MainGameFormID);
                    game.LockUIControl(mUIIDClay, Toolset.MainGameFormID); 
                    game.LockUIControl(mUIIDIron, Toolset.MainGameFormID);
                    game.LockUIControl(mUIIDLibrary, Toolset.MainGameFormID);
                    game.LockUIControl(mUIIDHospital, Toolset.MainGameFormID);
                                    }
                else if ((iNative >=4) && (iNative <=5))
            {
                    game.UnlockUIControl(mUIIDMarble, Toolset.MainGameFormID);
                    game.LockUIControl(mUIIDClay, Toolset.MainGameFormID); 
                    game.LockUIControl(mUIIDIron, Toolset.MainGameFormID);
                    game.LockUIControl(mUIIDLibrary, Toolset.MainGameFormID);
                    game.LockUIControl(mUIIDHospital, Toolset.MainGameFormID);
                                }

                else if ((iNative >= 6) && (iNative <= 8))
                                {
                    game.UnlockUIControl(mUIIDMarble, Toolset.MainGameFormID);
                    game.UnlockUIControl(mUIIDClay, Toolset.MainGameFormID);
                    game.UnlockUIControl(mUIIDIron, Toolset.MainGameFormID);
                    game.LockUIControl(mUIIDLibrary, Toolset.MainGameFormID);
                    game.LockUIControl(mUIIDHospital, Toolset.MainGameFormID);
                                }
                else              
                {
                    game.UnlockUIControl(mUIIDMarble, Toolset.MainGameFormID);
                    game.UnlockUIControl(mUIIDClay, Toolset.MainGameFormID); 
                    game.UnlockUIControl(mUIIDIron, Toolset.MainGameFormID);
                    game.UnlockUIControl(mUIIDLibrary, Toolset.MainGameFormID);
                    game.UnlockUIControl(mUIIDHospital, Toolset.MainGameFormID);
                                }
        }
        void CheckForSave(IGameQueryInterface game)
        {
            //save game and yearly debt messages

            switch (iSave)
            {
                case 1:
                        DisplayWarning(game, "10years");
                        tSave = 20;
                        iSave++;
                        break;

                case 2:
                        DisplayWarning(game, "Year1Debt");
                        tSave = 30;
                        iSave++;
                        break;
                case 3:
                        DisplayWarning(game, "NeptuneReminder");
                        tSave = 100;
                        iSave++;
                    break;
                case 4:
                        DisplayWarning(game, "NeptuneGarden");
                        DisplayWarning(game, "NeptuneAnkReminder");
                        tSave = 500;
                        iSave++;
                        break;
                case 5:
                        DisplayMessage(game, "2ndMarketNegotiated");
                        tSave = 900;
                        iSave++;
                        break;
                case 6:
                        DisplayWarning(game, "9years");
                        tSave = 980;
                        iSave++;
                    break;
                case 7:
                        DisplayWarning(game, "Year2Debt");
                        tSave = 1860;
                        iSave++;
                    break;
                case 8:
                        DisplayWarning(game, "8years");
                        tSave = 1940;
                        iSave++;
                    break;
                case 9:
                        DisplayWarning(game, "Year3Debt");
                        tSave = 2820;
                        iSave++;
                    break;
                case 10:
                        DisplayWarning(game, "7years");
                        tSave = 2900;
                        iSave++;
                    break;
                case 11:
                        DisplayWarning(game, "Year4Debt");
                        tSave = 3780;
                        iSave++;
                    break;
                case 12:
                        DisplayWarning(game, "6years");
                        tSave = 3860;
                        iSave++;
                    break;
                case 13:
                        DisplayWarning(game, "Year5Debt");
                        tSave = 4740;
                        iSave++;
                    break;
                case 14:
                        DisplayWarning(game, "5years");
                        tSave = 4820;
                        iSave++;
                    break;
                case 15:
                        DisplayWarning(game, "Year6Debt");
                        tSave = 5700;
                        iSave++;
                    break;
                case 16:
                        DisplayWarning(game, "4years");
                        tSave = 5780;
                        iSave++;
                    break;
                case 17:
                        DisplayWarning(game, "Year7Debt");
                        tSave = 6660;
                        iSave++;
                    break;
                case 18:
                        DisplayWarning(game, "3years");
                        tSave = 6740;
                        iSave++;
                    break;
                case 19:
                        DisplayWarning(game, "Year8Debt");
                        tSave = 7620;
                        iSave++;
                    break;
                case 20:
                        DisplayWarning(game, "2years");
                        tSave = 7700;
                        iSave++;
                    break;
                case 21:
                        DisplayWarning(game, "Year9Debt");
                        tSave = 8580;
                        iSave++;
                    break;
                case 22:
                        DisplayWarning(game, "1year");
                        tSave = 8660;
                        iSave++;
                    break;
                case 23:
                        DisplayWarning(game, "Year10Debt");
                        tSave = 9060;
                        iSave++;
                    break;
                case 24:
                        DisplayWarning(game, "6months");
                        tSave = 9500;
                        iSave++;
                    break;
                case 25:
                        DisplayWarning(game, "1month");
                        tSave = 9600;
                        iSave++;
                    break;            
                case 26:
                        game.ScriptDone = true;
                        game.OpenTradeRoute(0);
                    break;
            }
        }
        //////////////////////////////////////////////
        // interaction with natives
        void NativeTrade(IGameQueryInterface game)
        {
            switch (iNative)
            {
                case 1:
                    {
                    DisplayMessage(game, "EVENT_Natives_1");
                    iNative++;
                    tNative = nTime + 10;
                    bNative1 = true;
            }
                    break;

                case 2:
                    {
                    DisplayMessage(game, "EVENT_Natives_2");
                    iNative++;
                    tNative = nTime + 100;
                        bNative2 = true;
                    }              
                    break;

                case 3:
                    if (bMissionary3)                                 
                        {
                            DisplayMessage(game, "EVENT_Natives_3");
                            iNative++;
                            game.UnlockUIControl(mUIIDMarble, Toolset.MainGameFormID);
                            tNative = (nTime + 20);
                            bNative3 = true;
                        }                   
                   else
                       tNative = (nTime + 80);
                    break;

                case 4:
                    {
                        DisplayMessage(game, "EVENT_Natives_4");
                        iNative++;
                        tNative = (nTime + 140);
                        bNative4 = true;
                    }

                      break;

                  case 5:
                      if (bMissionary5)
                      {
                          DisplayMessage(game, "EVENT_Natives_5");
                          iNative++;
                        game.UnlockUIControl(mUIIDIron, Toolset.MainGameFormID);
                        game.UnlockUIControl(mUIIDClay, Toolset.MainGameFormID);
                        tNative = (nTime + 20);
                          bNative5 = true;
                      }
                      else
                          tNative = (nTime + 80);
                      break;

                  case 6:
{
                  msgTitle = "AsteroidAnnie_Title";
                  msgText = "AsteroidAnnie_Message";
                  msgSound = "message1.mp3";
                  game.SendGameMessage((uint)MessageCategory.kLocalEventMessage,
                    (uint)MessageDisplay.kMessageDisplayTutorial, ref msgTitle, ref msgText, ref msgSound);
                  iNative++;
                  tNative = (nTime + 20);
                  bNative6 = true;
}
                    break;

                case 7:
                    {
                        iNative++;
                        tNative = (nTime + 140);
                        bNative7 = true;
                    }
                    break;

                case 8:
                    if (bMissionary8)
                    {
                        DisplayMessage(game, "EVENT_Natives_8");
                        game.UnlockUIControl(mUIIDLibrary, Toolset.MainGameFormID);
                        game.UnlockUIControl(mUIIDHospital, Toolset.MainGameFormID);
                        iNative++;
                        tNative = (nTime + 140);
                        bNative8 = true;
                    }
                    else
                        tNative = (nTime + 80);
                    break;
                case 9:
                    if (bMissionary9)
                    {
                        DisplayMessage(game, "EVENT_Natives_9");
                        iNative++;
                        tNative = (nTime + 50);
                        bNative9 = true;
                    }
                    else
                        tNative = (nTime + 80);
                    break;

                case 10:
                    if (bMissionary10)
                    {
                        DisplayWarning(game, "EVENT_Natives_10");
                        iNative++;
                        tNative = (nTime + 140);
                        bNative10 = true;
                    }
                    else 
                        tNative = (nTime + 80);
                    break;


                case 11:
                    if (bTrade0)
                    {
                        DisplayMessage(game, "EVENT_Natives_11");
                        if (bTrade6) game.OpenTradeRoute(6);
                        else if (bTrade7) game.OpenTradeRoute(7);
                        else if (bTrade8) game.OpenTradeRoute(8);
                        iNative++;
                        tNative = (nTime + 50);
                        bNative11 = true;
                    }
                    else
                        tNative = (nTime + 80);
                    break;

                case 12:
                    {
                        DisplayMessage(game, "Spirit1");
                        bSpirit = true;
                        iNative++;
                        tNative = (nTime + 10);
                    }
                    break;

                case 13:
                    if (!bMissionary10)
                    {
                        game.CloseTradeRoute(6);
                        game.CloseTradeRoute(7);
                        game.CloseTradeRoute(8);
                        game.TriggerStructureDamage(mIDTradeDepot, 2, 100);
                        DisplayMessage(game, "Natives_Close_Trade");
                        iNative++;
                        bNative11 = false;
                        bTradeBoost6 = false;
                        bTradeBoost7 = false;
                        bTradeBoost8 = false;
                        tNative = (nTime + 10);
                        
                    }
                    break;

                case 14:
                    {
                        DisplayWarning(game, "NativeTradeDelay");
                        iNative = 10;
                        tNative = (nTime + 400);
                    }
                    break;

                case 15:
                    break;
                          
            }
        }
        void GetMissionaries(IGameQueryInterface game)
        {
            ///first part determine what level of native interaction you have
        
            game.GetActiveBuildings(mIDClinic, out numClinic);
            game.GetActiveBuildings(mIDJupiterTemple, out numJupiterTemple);
            game.GetActiveBuildings(mIDCeresTemple, out numCeresTemple);
            game.GetActiveBuildings(mIDMercuryTemple, out numMercuryTemple);
            game.GetActiveBuildings(mIDBacchusTemple, out numBacchusTemple);
            game.GetActiveBuildings(mIDMarsTemple, out numMarsTemple);
            game.GetActiveBuildings(mIDSchool, out numSchool);
            game.GetActiveBuildings(mIDLibrary, out numLibrary);
            game.GetActiveBuildings(mIDBathhouse, out numBathhouse);
            game.GetActiveBuildings(mIDBarber, out numBarber);
            game.GetActiveBuildings(mIDHospital, out numHospital);
            game.GetActiveBuildings(mIDStatue6, out numNeptuneTemple);



            if ((numClinic >= 1) && (numSchool >= 1))
                bMissionary3 = true;
            else bMissionary3 = false;
            if ((numClinic > 0) && (numSchool > 0) && (numNeptuneTemple > 0) && (numJupiterTemple > 0) && (numCeresTemple > 0) && (numMercuryTemple > 0) && (numBacchusTemple > 0) && (numMarsTemple > 0))
                bMissionary5 = true;
            else bMissionary5 = false;
            if ((numClinic >= 2) && (numSchool >= 2) && (numNeptuneTemple > 0) && (numJupiterTemple > 0) && (numCeresTemple > 0) && (numMercuryTemple > 0) && (numBacchusTemple > 0) && (numMarsTemple > 0))
                bMissionary8 = true;
            else bMissionary8 = false;
            if ((numLibrary > 0) && (numClinic > 1) && (numNeptuneTemple > 0) && (numSchool > 1) && (numJupiterTemple > 0) && (numCeresTemple > 0) && (numMercuryTemple > 0) && (numBacchusTemple > 0) && (numMarsTemple > 0))
                bMissionary9 = true;
            else bMissionary9 = false;

            if ((numHospital > 0) && (numLibrary > 0) && (numNeptuneTemple > 0) && (numClinic > 1) && (numSchool > 1) && (numJupiterTemple > 0) && (numCeresTemple > 0) && (numMercuryTemple > 0) && (numBacchusTemple > 0) && (numMarsTemple > 0) && (numBarber > 0) && (numBathhouse > 0))
                bMissionary10 = true;
            else bMissionary10 = false;

            //opens Victory trade route for cheat checking, commented out until checking entries

           // if (numHospital >= 10) game.OpenTradeRoute(1);
        }
    //This causes natives or market ladies to destroy your buildings if you upset them.

   void AngryNatives(IGameQueryInterface game)
   {
      game.GetActiveBuildings(mIDMarbleCamp, out numMarbleCamp);
      game.GetActiveBuildings(mIDClayCamp, out numClayCamp);
      game.GetActiveBuildings(mIDIronCamp, out numIronCamp);
      game.GetTotalBuildings(mIDFoodMarket, out numFoodMarket);
      game.GetTotalBuildings(mIDBasicMarket, out numBasicMarket);
      game.GetTotalBuildings(mIDLuxuryMarket, out numLuxuryMarket);
     
    if ((iNative >=4) && (numMarbleCamp >=2))
        {
    game.TriggerStructureDamage(mIDClayCamp, 2, 100);
    game.TriggerStructureDamage(mIDIronCamp, 2, 100);
    game.TriggerStructureDamage(mIDMarbleCamp, 2, 100);
    DisplayWarning(game, "Natives_Angry");
}
    else if ((iNative >= 6) && (iNative<=8) && (numClayCamp >=2))
        {
    game.TriggerStructureDamage(mIDClayCamp, 2, 100);
    game.TriggerStructureDamage(mIDIronCamp, 2, 100);
    game.TriggerStructureDamage(mIDMarbleCamp, 2, 100);
    DisplayWarning(game, "Natives_Angry");
}
    else if ((iNative >= 6) && (iNative<=8) && (numIronCamp >=2))
        {
    game.TriggerStructureDamage(mIDClayCamp, 2, 100);
    game.TriggerStructureDamage(mIDIronCamp, 2, 100);
    game.TriggerStructureDamage(mIDMarbleCamp, 2, 100);
    DisplayWarning(game, "Natives_Angry");
}
    else if ((iNative >=9) && (numClayCamp >=3))
        {
    game.TriggerStructureDamage(mIDClayCamp, 2, 100);
    game.TriggerStructureDamage(mIDIronCamp, 2, 100);
    game.TriggerStructureDamage(mIDMarbleCamp, 2, 100);
    DisplayWarning(game, "Natives_Angry");
}
    else if ((iNative >=9) && (numIronCamp >=3))
{
    game.TriggerStructureDamage(mIDClayCamp, 2, 100);
    game.TriggerStructureDamage(mIDIronCamp, 2, 100);
    game.TriggerStructureDamage(mIDMarbleCamp, 2, 100);
    DisplayWarning(game, "Natives_Angry");
            }
    else if ((((numFoodMarket) + (numBasicMarket) + (numLuxuryMarket)) >= 2) && (!bExtraMarket))
            {
    game.TriggerStructureDamage(mIDBasicMarket, 10, 100);
    game.TriggerStructureDamage(mIDFoodMarket, 10, 100);
    game.TriggerStructureDamage(mIDLuxuryMarket, 10, 100);
    DisplayWarning(game, "MarketLadies_Angry");
   }
   else if ((((numFoodMarket) + (numBasicMarket) + (numLuxuryMarket)) >= 3) && (bExtraMarket))
   {
       game.TriggerStructureDamage(mIDBasicMarket, 10, 100);
       game.TriggerStructureDamage(mIDFoodMarket, 10, 100);
       game.TriggerStructureDamage(mIDLuxuryMarket, 10, 100);
       DisplayWarning(game, "MarketLadies_Angry");
   }
       
       tCollapse = (nTime + 20);

   }
         //this routine determines which native trade route to open 
        //if 2 or more somehow open, defeat occurs (this should not happen)

        void DetermineTradeRoute(IGameQueryInterface game)
        {
            game.GetIsTradeRouteOpen(3, out bTrade3);
            game.GetIsTradeRouteOpen(4, out bTrade4);
            game.GetIsTradeRouteOpen(5, out bTrade5);
            game.GetIsTradeRouteOpen(2, out bTrade2);


            if ((bTrade3) && (!bTrade4) && (!bTrade5) && (!bTrade0))
            {
                bTrade6 = true;
                bTrade0 = true;
            }
            else if ((!bTrade3) && (bTrade4) && (!bTrade5) && (!bTrade0))
            {
                bTrade7 = true;
                bTrade0 = true;
            }
            else if ((!bTrade3) && (!bTrade4) && (bTrade5) && (!bTrade0))
            {
                bTrade8 = true;
                bTrade0 = true;
            }
            else if ((bTrade3) && (bTrade4) && (!bTrade5) && (!bTrade0))
            {
                bTrade8 = true;
                bTrade0 = true;
            }
            else if ((bTrade3) && (!bTrade4) && (bTrade5) && (!bTrade0))
            {
                bTrade7 = true;
                bTrade0 = true;
            }
            else if ((!bTrade3) && (bTrade4) && (bTrade5) && (!bTrade0))
            {
                bTrade6 = true;
                bTrade0 = true;
            }
            else if ((bTrade3) && (bTrade4) && (bTrade5) && (!bTrade0))
            {
                bTrade8 = true;
                bTrade0 = true;
            }
            
                if ((bTrade6) && (bTrade7)) game.OpenTradeRoute(0);
                else if ((bTrade6) && (bTrade8)) game.OpenTradeRoute(0);
                else if ((bTrade7) && (bTrade8)) game.OpenTradeRoute(0);
                else if ((bTrade0) && (!bSeaTrade))
                {
                    DisplayWarning(game, "SeaTrade");
                    bSeaTrade = true;
                }
        }
        void GetWages(IGameQueryInterface game)
        {
            game.GetActiveBuildings(mIDClinic, out numClinic);
            game.GetActiveBuildings(mIDBathhouse, out numBathhouse);
            game.GetActiveBuildings(mIDBarber, out numBarber);
            game.GetActiveBuildings(mIDHospital, out numHospital);
            game.GetActiveBuildings(mIDOdeum, out numOdeum);
            game.GetActiveBuildings(mIDTheater, out numTheater);
            game.GetActiveBuildings(mIDArena, out numArena);
            game.GetActiveBuildings(mIDActor, out numActor);
            game.GetActiveBuildings(mIDGladiator, out numGladiator);
            game.GetActiveBuildings(mIDJupiterTemple, out numJupiterTemple);
            game.GetActiveBuildings(mIDCeresTemple, out numCeresTemple);
            game.GetActiveBuildings(mIDMercuryTemple, out numMercuryTemple);
            game.GetActiveBuildings(mIDBacchusTemple, out numBacchusTemple);
            game.GetActiveBuildings(mIDMarsTemple, out numMarsTemple);
            game.GetActiveBuildings(mIDSchool, out numSchool);
            game.GetActiveBuildings(mIDLibrary, out numLibrary);
            game.GetActiveBuildings(mIDTaxOffice, out numTaxOffice);
            game.GetActiveBuildings(mIDFountain, out numFountain);
            game.GetActiveBuildings(mIDReservoir, out numReservoir);
            game.GetActiveBuildings(mIDPumphouse, out numPumphouse);
            game.GetActiveBuildings(mIDDrillYard, out numDrillYard);
            game.GetActiveBuildings(mIDStatue6, out numNeptuneTemple);


            if (numClinic >= (numClinicOld + 1)) numClinicOld = numClinic; 
            if (numBathhouse >= (numBathhouseOld + 1)) numBathhouseOld = numBathhouse;
            if (numBarber >= (numBarberOld + 1)) numBarberOld = numBarber;
            if (numHospital >= (numHospitalOld + 1)) numHospitalOld = numHospital;
            if (numOdeum >= (numOdeumOld + 1)) numOdeumOld = numOdeum;
            if (numTheater >= (numTheaterOld + 1)) numTheaterOld = numTheater;
            if (numArena >= (numArenaOld + 1)) numArenaOld = numArena;
            if (numActor >= (numActorOld + 1)) numActorOld = numActor;
            if (numGladiator >= (numGladiatorOld + 1)) numGladiatorOld = numGladiator;
            if (numJupiterTemple >= (numJupiterTempleOld + 1)) numJupiterTempleOld = numJupiterTemple;
            if (numCeresTemple >= (numCeresTempleOld + 1)) numCeresTempleOld = numCeresTemple;
            if (numMercuryTemple >= (numMercuryTempleOld + 1)) numMercuryTempleOld = numMercuryTemple;
            if (numMarsTemple >= (numMarsTempleOld + 1)) numMarsTempleOld = numMarsTemple;
            if (numBacchusTemple >= (numBacchusTempleOld + 1)) numBacchusTempleOld = numBacchusTemple;
            if (numSchool >= (numSchoolOld + 1)) numSchoolOld = numSchool;
            if (numLibrary >= (numLibraryOld + 1)) numLibraryOld = numLibrary;
            if (numTaxOffice >= (numTaxOfficeOld + 1)) numTaxOfficeOld = numTaxOffice;
            if (numFountain >= (numFountainOld + 1)) numFountainOld = numFountain;
            if (numReservoir >= (numReservoirOld + 1)) numReservoirOld = numReservoir;
            if (numPumphouse >= (numPumphouseOld + 1)) numPumphouseOld = numPumphouse;
            if (numDrillYard >= (numDrillYardOld + 1)) numDrillYardOld = numDrillYard;
            if (numNeptuneTemple >= (numNeptuneTempleOld + 1)) numNeptuneTempleOld = numNeptuneTemple;


            numTotalEquiteAssessment = (((numClinicOld * 2) + (numBathhouseOld * 2) + (numBarberOld * 1) + (numHospitalOld * 4) + (numOdeumOld * 2) + (numTheaterOld * 2) + (numArenaOld * 3) + (numActorOld * 2) + (numGladiatorOld * 2) + (numJupiterTempleOld * 3) + (numMercuryTempleOld * 3) + (numMarsTempleOld * 3) + (numBacchusTempleOld * 3) + (numCeresTempleOld * 3) + (numNeptuneTempleOld * 3) + (numSchoolOld * 2) + (numLibraryOld * 3) + (numTaxOfficeOld) + (numFountainOld) + (numReservoirOld * 2) + (numPumphouseOld * 2) + (numDrillYardOld * 4)) * 4 / 5);

  ////////////////////////////////////////////////////////////////////////////
        // Adjust Pleb & Equite wages in accordance with TotalEquiteAssessment- max 8dn rise for equites each 12 months, plebs 50% equites
          
            if (numTotalEquiteAssessment >= ((numOldEquiteAssessment) + 8))
            {
                numEquiteWages+=8;
                numPlebWages = (numEquiteWages / 2);
                game.SetRomeStandardRate(true, numPlebWages);
                game.SetRomeStandardRate(false, numEquiteWages);
                numAdjEquiteAssessment = (numOldEquiteAssessment + 8);
                numOldEquiteAssessment = numAdjEquiteAssessment;
                // now advise player of raised expectations
                DisplayWarning(game, "Wage_Change");
            }
                 
            tWageCheck = nTime + 960;           // next check in 3 months time
        }
                /////////////////////////////////////////////
     // Send basic message to player
     void DisplayMessage(IGameQueryInterface game, String sMessage)
     {
         msgTitle = sMessage + "_Title";
         msgText = sMessage + "_Text";
         msgSound = "message1.mp3";

         game.SendGameMessage((uint)MessageCategory.kLocalEventMessage,
             (uint)MessageDisplay.kMessageDisplaySignificant, ref msgTitle, ref msgText, ref msgSound);
     }
        void DisplayWarning(IGameQueryInterface game, String sMessage)
        {
            msgWarn = sMessage + "_Warning";
            msgSound = "message1.mp3";
            game.SendWarningMessage(ref msgWarn, ref msgSound);
        }
        void InvasionSequence(IGameQueryInterface game)
        {
            String invasion;
            String orders = sCohortOrders.kRetreat;
            Int32[] iCohorts;
            InvasionSetup mInvasion;
            //iInvasions = 25;

            switch (iInvasions)
            {
                case 1:
                    DisplayMessage(game, "Invasion1Distant");
                    iInvasions++;
                    tInvasions = 1020;
                    break;

                case 2:
                    DisplayMessage(game, "Invasion1Near");
                    iInvasions++;
                    tInvasions = 1180;
                    break;

                case 3:
                    invasion = "invasion1";
                    mInvasion = new InvasionSetup(invasion, "Gaul", eInvasionType.kRaid, 2500, 4, 0);
                    mInvasion.AddCohort("ENEMY_GAUL_LT", 3, 1, 2);
                    mInvasion.CreateInvasion(game, 1, 0);
                    game.StartInvasion(ref invasion);
                    DisplayMessage(game, "Invasion1Arrive");
                    iInvasions++;
                    tInvasions = 1200;
                    break;

                case 4:
                    // spirit of asteroid annie

                    if (bSpirit)
                    {
                        iInvasions++;
                        tInvasions = 1800;
                        bSpirit = false;
                        invasion = "invasion1";
                        DisplayMessage(game, "Spirit2");
                        game.StopInvasion(ref invasion, true);
                        game.GetInvaderCohorts(ref invasion, out iCohorts);
                        foreach (Int32 cohortID in iCohorts)
                            game.SetCohortOrders(cohortID, ref orders);
                        
                    }
                    else
                    {
                        iInvasions++;
                        tInvasions = 1800;
                    }
                    break;

                case 5:
                    DisplayMessage(game, "AARepeat");
                    iInvasions++;
                    tInvasions = 1960;
                    break;

                case 6:
                    DisplayMessage(game, "Invasion2Near");
                    iInvasions++;
                    tInvasions = 2120;
                    break;

                case 7:
                    invasion = "invasion2";
                    mInvasion = new InvasionSetup(invasion, "Gaul", eInvasionType.kRaid, 3000, 4, 0);
                    mInvasion.AddCohort("ENEMY_GAUL_HVY", 2, 3, 4);
                    mInvasion.AddCohort("ENEMY_GAUL_AUX", 2, 3, 4);
                    mInvasion.CreateInvasion(game, 1, 0);
                    game.StartInvasion(ref invasion);
                    DisplayMessage(game, "Invasion2Arrive");
                    iInvasions++;
                    tInvasions = 2140;
                    break;

                case 8:
                    // spirit of asteroid annie

                    if (bSpirit)
                    {
                        iInvasions++;
                        tInvasions = 2800;
                        bSpirit = false; 
                        DisplayMessage(game, "Spirit2");
                        invasion = "invasion2";
                        game.StopInvasion(ref invasion, true);
                        game.GetInvaderCohorts(ref invasion, out iCohorts);
                        foreach (Int32 cohortID in iCohorts)
                            game.SetCohortOrders(cohortID, ref orders);
                   }
                    else
                    {
                        iInvasions++;
                        tInvasions = 2800;
                    }
                    break;

                case 9:
                    DisplayMessage(game, "Invasion3Near");
                    iInvasions++;
                    tInvasions = 2960;
                    break;

                case 10:
                    invasion = "invasion3";
                    mInvasion = new InvasionSetup(invasion, "Parthian", eInvasionType.kRaid, 3500, 4, 0);
                    mInvasion.AddCohort("ENEMY_PARTH_CAV", 2, 5, 6);
                    mInvasion.AddCohort("ENEMY_PARTH_AUX", 2, 2, 1);
                    mInvasion.AddCohort("ENEMY_PARTH_LT", 2, 4, 3);
                    mInvasion.CreateInvasion(game, 1, 0);
                    game.StartInvasion(ref invasion);
                    DisplayMessage(game, "Invasion3Arrive");
                    iInvasions++;
                    tInvasions = 3000;
                    break;

                case 11:
                    // spirit of asteroid annie

                    if (bSpirit)
                    {
                        iInvasions++;
                        tInvasions = 3600;
                        bSpirit = false;
                        DisplayMessage(game, "Spirit2");
                        invasion = "invasion3";
                        game.StopInvasion(ref invasion, true);
                        game.GetInvaderCohorts(ref invasion, out iCohorts);
                        foreach (Int32 cohortID in iCohorts)
                            game.SetCohortOrders(cohortID, ref orders);
                    }
                    else
                    {
                        iInvasions++;
                        tInvasions = 3600;
                    }
                    break;

                case 12:
                    DisplayMessage(game, "Invasion4Near");
                    iInvasions++;
                    tInvasions = 3760;
                    break;

                case 13:

                    invasion = "invasion4";
                    mInvasion = new InvasionSetup(invasion, "Parthian", eInvasionType.kRaid, 4000, 4, 0);
                    mInvasion.AddCohort("ENEMY_PARTH_CAV", 2, 6, 5);
                    mInvasion.AddCohort("ENEMY_PARTH_HVY", 2, 2, 3);
                    mInvasion.AddCohort("ENEMY_PARTH_LT", 2, 3, 2);
                    mInvasion.CreateInvasion(game, 1, 0);
                    game.StartInvasion(ref invasion);
                    DisplayMessage(game, "Invasion4Arrive");
                    iInvasions++;
                    tInvasions = 3800;
                    break;

                case 14:
                    // spirit of asteroid annie

                    if (bSpirit)
                    {
                        iInvasions++;
                        tInvasions = 4550;
                        bSpirit = false;
                        invasion = "invasion4";
                        DisplayMessage(game, "Spirit2");
                        game.StopInvasion(ref invasion, true);
                        game.GetInvaderCohorts(ref invasion, out iCohorts);
                        foreach (Int32 cohortID in iCohorts)
                            game.SetCohortOrders(cohortID, ref orders);
                    }
                    else
                    {
                        iInvasions++;
                        tInvasions = 4550;
                    }
                    break;

                case 15:
                    DisplayMessage(game, "Invasion5Near");
                    iInvasions++;
                    tInvasions = 4710;
                    break;

                case 16:

                    invasion = "invasion5";
                    mInvasion = new InvasionSetup(invasion, "Parthian", eInvasionType.kRaid, 4500, 4, 0);
                    mInvasion.AddCohort("ENEMY_PARTH_CAV", 4, 1, 6);
                    mInvasion.AddCohort("ENEMY_PARTH_HVY", 4, 2, 4);
                    mInvasion.CreateInvasion(game, 1, 0);
                    game.StartInvasion(ref invasion);
                    DisplayMessage(game, "Invasion5Arrive");
                    iInvasions++;
                    tInvasions = 4750;
                    break;

                case 17:

                    // spirit of asteroid annie

                    if (bSpirit)
                    {
                        iInvasions++;
                        tInvasions = 6450;
                        bSpirit = false;
                        DisplayMessage(game, "Spirit2");
                        invasion = "invasion5";
                        game.StopInvasion(ref invasion, true);
                        game.GetInvaderCohorts(ref invasion, out iCohorts);
                        foreach (Int32 cohortID in iCohorts)
                            game.SetCohortOrders(cohortID, ref orders);
                   }
                    else
                    {
                        iInvasions++;
                        tInvasions = 6450;
                    }
                    break;

                case 18:
                    DisplayMessage(game, "Invasion6Near");
                    iInvasions++;
                    tInvasions = 6610;
                    break;

                case 19:

                    invasion = "invasion6";
                    mInvasion = new InvasionSetup(invasion, "Gaul", eInvasionType.kRaid, 5000, 4, 0);
                    mInvasion.AddCohort("ENEMY_GAUL_AUX", 4, 1, 6);
                    mInvasion.AddCohort("ENEMY_GAUL_LT", 4, 2, 4);
                    mInvasion.CreateInvasion(game, 1, 0);
                    game.StartInvasion(ref invasion);
                    DisplayMessage(game, "Invasion6Arrive");
                    iInvasions++;
                    tInvasions = 6650;
                    break;

                case 20:

                    // spirit of asteroid annie

                    if (bSpirit)
                    {
                        iInvasions++;
                        tInvasions = 8800;
                        bSpirit = false;
                        DisplayMessage(game, "Spirit2");
                        invasion = "invasion6";
                        game.StopInvasion(ref invasion, true);
                        game.GetInvaderCohorts(ref invasion, out iCohorts);
                        foreach (Int32 cohortID in iCohorts)
                            game.SetCohortOrders(cohortID, ref orders);
                   }
                    else
                    {
                        iInvasions++;
                        tInvasions = 8800;
                    }
                    break;

                case 21:

                    DisplayMessage(game, "Invasion7Near");
                    iInvasions++;
                    tInvasions = 8960;
                    break;

                case 22:

                    invasion = "invasion7";
                    mInvasion = new InvasionSetup(invasion, "Gaul", eInvasionType.kRaid, 5000, 4, 0);
                    mInvasion.AddCohort("ENEMY_GAUL_AUX", 5, 1, 6);
                    mInvasion.AddCohort("ENEMY_GAUL_LT", 5, 6, 1);
                    mInvasion.CreateInvasion(game, 1, 0);
                    game.StartInvasion(ref invasion);
                    DisplayMessage(game, "Invasion7Arrive");
                    iInvasions++;
                    tInvasions = 8980;
                    break;

                case 23:

                    invasion = "invasion8";
                    mInvasion = new InvasionSetup(invasion, "Parthian", eInvasionType.kRaid, 5000, 4, 0);
                    mInvasion.AddCohort("ENEMY_PARTH_AUX", 6, 1, 6);
                    mInvasion.AddCohort("ENEMY_PARTH_LT", 6, 6, 1);
                    mInvasion.CreateInvasion(game, 1, 0);
                    game.StartInvasion(ref invasion);
                    DisplayMessage(game, "Invasion8Arrive");
                    iInvasions++;
                    tInvasions = 9000;
                    break;

                case 24:

                    // spirit of asteroid annie

                    if (bSpirit)
                    {
                        iInvasions++;
                        tInvasions = 9700;
                        bSpirit = false;
                        DisplayMessage(game, "Spirit2");
                        invasion = "invasion7";
                        game.StopInvasion(ref invasion, true);
                        game.GetInvaderCohorts(ref invasion, out iCohorts);
                        foreach (Int32 cohortID in iCohorts)
                            game.SetCohortOrders(cohortID, ref orders);
                   }
                    else
                    {
                        iInvasions++;
                        tInvasions = 9700;
                    }
                    break;

                case 25:

                    break;
            }
        }
        
        void OnScenarioLoad(IGameQueryInterface game)
       
            {
                bInit = true;
                game.ScriptDone = false;
        }

        void OnBeginScenario(IGameQueryInterface game)
        {
            bInit = true;
            game.ScriptDone = false;
        }
           
   
            void OnInvasionArrival(IGameQueryInterface game)
        {
            // let's find out which invasion we are...
            foreach (InvasionSetup inv in mInvasions)
            //
            if (game.RunInvasion == inv.GetInvasionName())
            {
                // hook into military AI
                eInvasionType invType = inv.GetInvasionType();
                mMilitaryAI.InvasionBegin(invType, game);
                break;
            }
        }


        void OnCohortTargetDestroyed(IGameQueryInterface game)
        {
            // see what we should be doing next
            String nextOrders = mMilitaryAI.InvasionTargetDestroyed(game.RunCohortID, game);
            game.SetCohortOrders(game.RunCohortID, ref nextOrders);
        }

}

    }

